const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const app_settings = sequelize.define(
    'app_settings',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

accounting_coding_mode: {
        type: DataTypes.ENUM,
      
      

        values: [

"government",


"private"

        ],

      },

analytic_levels_count: {
        type: DataTypes.INTEGER,
      
      

      },

enable_branching: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

enable_multi_currency: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

enable_document_workflow: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

enable_network_dongle: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

default_currency_code: {
        type: DataTypes.TEXT,
      
      

      },

numbering_profile_code: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  app_settings.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

















































//end loop



    db.app_settings.belongsTo(db.businesses, {
      as: 'business',
      foreignKey: {
        name: 'businessId',
      },
      constraints: false,
    });




    db.app_settings.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.app_settings.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return app_settings;
};


